package br.UFSC.GRIMA.bancoDeDados;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.Vector;

import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;

import br.UFSC.GRIMA.capp.CAPP;
import br.UFSC.GRIMA.util.projeto.Projeto;

/**
 * Fun��o que faz todo o tipo de acesso ao banco de dados.
 * 
 * @author roman
 * 
 */
public class AcessaBD extends Conexao {
	private Connection conexao;

	private String Query = new String();
	private int userID;
	private ResultSet rs = null;
	private Statement statement;
	private Dimension d;

	public AcessaBD(int userID) {
		this.userID = userID;
		setConn("grima.ufsc.br:3306", "webcad", "webcad", "julio123");
		conexao = getConn();
	}

	public AcessaBD(String host, String banco, String user, String senha) {
		setConn(host, banco, user, senha);
		conexao = getConn();
	}

	public String getProjetoPorID(int id) {
		Query = "SELECT * FROM projetos WHERE Usuario = " + userID
				+ " ORDER BY id ";
		String bbb;
		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			rs.next();
			while (id > 0) {
				rs.next();
				id--;
			}

			bbb = rs.getString("dados_cad");
			return bbb;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao acessar o banco de dados do sistema.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return null;
	}

	public String getOrdemPorID(int id) {
		Query = "SELECT * FROM ordens1 order by Id";
		String bbb = "";
		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			rs.next();
			while (id > 0) {
				rs.next();
				id--;
			}

			bbb = rs.getString("codigo_hpgl");
			return bbb;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao acessar o banco de dados do sistema.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return null;
	}

	public String[] listaProgeto() {
		Query = "SELECT * FROM projetos WHERE Usuario = " + userID
				+ " ORDER BY id";
		String[] ttt;
		int i = 0;
		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			while (rs.next()) {
				i++;
			}
			ttt = new String[i];
			rs.first();
			i = 0;
			if (ttt.length == 0) {
				return ttt;
			}

			do {
				ttt[i] = rs.getString("nome_projeto") + " : "
						+ rs.getString("data_mod");
				i++;

			} while (rs.next());

			return ttt;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao acessar o banco de dados.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return null;
	}

	public String[] listaOrdem() {
		Query = "SELECT * FROM ordens1  ORDER BY id";
		String[] ttt;
		int i = 0;
		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			while (rs.next()) {
				i++;
			}
			ttt = new String[i];
			rs.first();
			i = 0;
			if (ttt.length == 0) {
				return ttt;
			}

			do {
				ttt[i] = "nome da ordem:" + rs.getString("nome_ordem")
						+ "    data: " + rs.getString("data_mod")
						+ "   usuario: " + rs.getString("usuario");
				i++;

			} while (rs.next());

			return ttt;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao acessar o banco de dados.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return null;
	}

	public boolean salvoNoBD(Projeto projeto) {
		Query = "SELECT * FROM projetos WHERE nome_projeto = '"
				+ projeto.getDadosDeProjeto().getProjectName() + "'"
				+ " AND usuario = " + projeto.getDadosDeProjeto().getUserID();

		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			if (rs.next())
				return true;
		} catch (SQLException e) {
			JOptionPane.showMessageDialog(null,
					"Erro ao conectar com o servidor.", "Erro", 0);
		}

		return false;
	}

	public boolean insertProjeto(Projeto projeto, String sss) {

		Query = "INSERT INTO projetos (nome_projeto, usuario, dados_cad, hora, data, hora_mod, data_mod) VALUES ('"
				+ projeto.getDadosDeProjeto().getProjectName()
				+ "', '"
				+ projeto.getDadosDeProjeto().getUserID()
				+ "', '"
				+ sss
				+ "', "
				+ "CURRENT_TIME"
				+ ", "
				+ "CURRENT_DATE"
				+ ", "
				+ "CURRENT_TIME" + ", " + "CURRENT_DATE" + ")";

		try {
			statement = conexao.createStatement();
			statement.executeUpdate(Query);
			return true;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao inserir o novo projeto no banco de dados do sistema.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return false;
	}

	public boolean incProntas() {
		Query = "UPDATE ordens1 SET prontas = " + "'" + "'" + ", data_mod = "
				+ "CURRENT_DATE" + " WHERE nome_projeto =";

		try {
			statement = conexao.createStatement();
			statement.executeUpdate(Query);
			return true;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao inserir o novo projeto no banco de dados do sistema.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return false;
	}

	public boolean insertOrdem(Projeto projeto, String sss, CAPP capp,
			String material, int quantidade) {

		Query = "INSERT INTO ordens1 (usuario, projeto, material,"
				+ " quantidade, codigo_hpgl, prontas, mensagem, "
				+ "status, hora, data, hora_mod, data_mod) VALUES ('"
				+ projeto.getDadosDeProjeto().getUserID()
				+ "', '"
				+ sss
				+ "', '"
				+ material
				+ "', '"
				+ quantidade
				+ "', '"
				+ capp.codigoHPGL_texto
				+ "', '"
				+ "0"
				+ "', '"
				+ "ok"
				+ "', '"
				+ "aguardando fabrica��o"
				+ "', "
				+ "CURRENT_TIME"
				+ ", "
				+ "CURRENT_DATE"
				+ ", "
				+ "CURRENT_TIME"
				+ ", "
				+ "CURRENT_DATE" + ")";

		/*
		 * projeto.getDadosDeProjeto().getProjectName() + "', '" +
		 * projeto.getDadosDeProjeto().getUserID() + "', '" + sss + "', " +
		 * "CURRENT_TIME" + ", " + "CURRENT_DATE" + ", " + "CURRENT_TIME" + ", "
		 * + "CURRENT_DATE" +")";
		 */

		try {
			statement = conexao.createStatement();
			statement.executeUpdate(Query);
			return true;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao inserir a ordem de fabrica��o no banco de dados do sistema.\nTente novamente mais tarde.",
							"Erro", 0);
		}

		return false;
	}

	public boolean updateProjeto(Projeto projeto, String vv) {
		Query = "UPDATE projetos SET dados_cad = " + "'" + vv + "'"
				+ ", data_mod = " + "CURRENT_DATE" + " WHERE nome_projeto ="
				+ "'" + projeto.getDadosDeProjeto().getProjectName() + "'"
				+ " AND usuario = " + projeto.getDadosDeProjeto().getUserID();

		try {
			statement = conexao.createStatement();
			statement.executeUpdate(Query);
			return true;
		} catch (SQLException e) {
			JOptionPane
					.showMessageDialog(
							null,
							"Erro ao inserir o novo projeto no banco de dados do sistema.\nTente novamente mais tarde.",
							"Erro", 0);
			e.printStackTrace();
		}

		return false;
	}

	/*
	 * obtem tabela com informa��es dos pedidos
	 */
	public JTable getdados(String tablename) {
		JTable table = null;
		Vector columnHeads, rows;
		Query = "SELECT * FROM " + tablename + " ORDER BY Id DESC";

		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			if (rs.next()) {
				columnHeads = new Vector();
				rows = new Vector();

				String[] columnNames = { "ID-circ", "ID-user", "Circuito",
						"Quant", "Status", "Manufatura", "Tam X", "Tam Y" };

				try {
					ResultSetMetaData rsmd = rs.getMetaData();
					for (int i = 1; i <= rsmd.getColumnCount(); ++i)
						columnHeads
								.addElement(/* rsmd.getColumnName(pointIndex) */columnNames[i - 1]);

					Vector currentRow;
					do {
						currentRow = new Vector();
						for (int i = 1; i <= rsmd.getColumnCount(); ++i)
							switch (rsmd.getColumnType(i)) {
							case Types.VARCHAR:
								currentRow.addElement(rs.getString(i));
								break;
							case Types.INTEGER:
								currentRow.addElement(new Long(rs.getLong(i)));
								break;
							case Types.CHAR:
								currentRow.addElement(rs.getString(i));
								break;
							case Types.LONGVARCHAR:
								currentRow.addElement(rs.getString(i));
								break;
							default:
								System.out.println("Tipos de dados: "
										+ rsmd.getColumnTypeName(i));
							}
						rows.addElement(currentRow);
					} while (rs.next());

					table = new JTable(rows, columnHeads);
					d = Toolkit.getDefaultToolkit().getScreenSize();
					d.height = d.height / 4;
					d.width = d.width / 5;
					table.setPreferredScrollableViewportSize(d);
					table.setEnabled(false);
					table.getColumn("Mesa").setMinWidth(80);
				} catch (SQLException e) {
					JOptionPane.showMessageDialog(null,
							"Erro ao criar Tabela!", "Erro", 0);
				}
			}
			// else System.out.println("tabela vazia!!");
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Erro1", "Erro", 0);
			e.printStackTrace();
		}

		if (table != null) {
			table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			// table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			table.setDragEnabled(false);
		}

		return table;
	}

	/*
	 * obtem tabela com informa��es das mesas
	 */
	public JTable getmesas(String tablename) {
		JTable table = null;
		Vector columnHeads, rows;
		Query = "SELECT * FROM " + tablename + " ORDER BY id DESC";

		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			if (rs.next()) {
				columnHeads = new Vector();
				rows = new Vector();

				String[] columnNames = { "ID-mesa", "Nome", "Tam x", "Tam y",
						"Agente", "Veloc", "Status" };

				try {
					ResultSetMetaData rsmd = rs.getMetaData();
					for (int i = 1; i <= rsmd.getColumnCount(); ++i)
						columnHeads
								.addElement(/* rsmd.getColumnName(pointIndex) */columnNames[i - 1]);

					Vector currentRow;
					do {
						currentRow = new Vector();
						for (int i = 1; i <= rsmd.getColumnCount(); ++i)
							switch (rsmd.getColumnType(i)) {
							case Types.VARCHAR:
								currentRow.addElement(rs.getString(i));
								break;
							case Types.INTEGER:
								currentRow.addElement(new Long(rs.getLong(i)));
								break;
							case Types.CHAR:
								currentRow.addElement(rs.getString(i));
								break;
							case Types.OTHER:
								currentRow.addElement((String) rs.getObject(i));
								break;
							case Types.LONGVARCHAR:
								currentRow.addElement(rs.getString(i));
								break;
							default:
								System.out.println("Tipos de dados: "
										+ rsmd.getColumnTypeName(i));
							}
						rows.addElement(currentRow);
					} while (rs.next());

					table = new JTable(rows, columnHeads);
					d = Toolkit.getDefaultToolkit().getScreenSize();
					d.height = d.height / 3;
					d.width = d.width / 2 - d.width / 10;
					table.setPreferredScrollableViewportSize(d);
					table.getColumn("Nome").setMinWidth(80);
					table.getColumn("Agente").setMinWidth(80);
				} catch (SQLException e) {
					JOptionPane.showMessageDialog(null,
							"Erro ao criar Tabela!", "Erro", 0);
				}
			}
			// else
			// System.out.println("Nao existem registros na tabela de mesas!!");
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Erro1", "Erro", 0);
			e.printStackTrace();
		}

		if (table != null) {
			table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			// table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			table.setDragEnabled(false);
		}
		return table;
	}

	/*
	 * retorna Vetor de vetores que s�o todos os pedidos n�o processados
	 */
	public Vector buscapedidos(String tabela) {
		Vector busca = null;
		Query = "SELECT * FROM " + tabela
				+ " WHERE status = 0 ORDER BY idcircuito";
		Vector pedidos = null;
		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			if (rs.next()) {
				try {
					ResultSetMetaData rsmd = rs.getMetaData();
					pedidos = new Vector();
					do {
						busca = new Vector();
						for (int i = 1; i <= rsmd.getColumnCount(); ++i) {
							switch (rsmd.getColumnType(i)) {
							case Types.VARCHAR:
								busca.addElement(rs.getString(i));
								break;
							case Types.INTEGER:
								busca.addElement(new Long(rs.getLong(i)));
								break;
							case Types.CHAR:
								busca.addElement(rs.getString(i));
								break;
							case Types.LONGVARCHAR:
								busca.addElement(rs.getString(i));
								break;
							default:
								System.out.println("Tipos de dados: "
										+ rsmd.getColumnTypeName(i));
							}
						}
						pedidos.addElement(busca);
					} while (rs.next());
				} catch (SQLException e) {
					JOptionPane.showMessageDialog(null,
							"Erro ao criar Tabela!", "Erro", 0);
				}
			}
			// else System.out.println("Nao existem processos!!");
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Erro1", "Erro", 0);
			e.printStackTrace();
		}

		return pedidos;
	}

	/*
	 * Busca mesas que podem executar o circuito enviado
	 */
	public Vector buscamesas(String tabela, int xmax, int ymax) {
		Vector mesas = null;
		Vector busca;
		// for (int j=0; j<agentes.size(); j++)
		// {
		Query = "SELECT * FROM " + tabela + " WHERE (status = 1) AND ((tamx > "
				+ xmax + ") AND (tamy > " + ymax + ")) ORDER BY id";
		try {
			statement = conexao.createStatement();
			rs = statement.executeQuery(Query);
			if (rs.next()) {
				try {
					ResultSetMetaData rsmd = rs.getMetaData();
					mesas = new Vector();
					do {
						busca = new Vector();
						for (int i = 1; i <= rsmd.getColumnCount(); ++i)
							switch (rsmd.getColumnType(i)) {
							case Types.VARCHAR:
								busca.addElement(rs.getString(i));
								break;
							case Types.INTEGER:
								busca.addElement(new Long(rs.getLong(i)));
								break;
							case Types.CHAR:
								busca.addElement(rs.getString(i));
								break;
							case Types.OTHER:
								busca.addElement((String) rs.getObject(i));
								break;
							case Types.LONGVARCHAR:
								busca.addElement(rs.getString(i));
								break;
							default:
								System.out.println("Tipos de dados: "
										+ rsmd.getColumnTypeName(i));
							}
						mesas.addElement(busca);
					} while (rs.next());
				} catch (SQLException e) {
					JOptionPane.showMessageDialog(null,
							"Erro ao criar Tabela!", "Erro", 0);
				}
			}
			// else System.out.println("Nao existe esta mesa com processo");
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Erro1", "Erro", 0);
			e.printStackTrace();
		}
		// }
		return mesas;
	}

	/*
	 * 
	 * public void removepedido(String tabela, Long idTemp) { Query =
	 * "DELETE FROM " + tabela + " WHERE id='" + idTemp + "'";
	 * 
	 * try { stm = con.createStatement(); stm.executeUpdate(Query); } catch
	 * (SQLException e){JOptionPane.showMessageDialog(null,
	 * "Erro ao remover pedido", "Erro", 0);} }
	 * 
	 * public void saveContacts(String tabela) { Query =
	 * "SELECT name, lastname, mailpri, homephone, celphone, msn INTO OUTFILE \"E:/Users/Roman/Agenda/Atual/Arquivos/"
	 * + tabela + "_contacts.txt\" FROM t_" +tabela;
	 * //System.out.println(Query);
	 * 
	 * try { stm = con.createStatement(); stm.executeQuery(Query);
	 * JOptionPane.showMessageDialog(null, "Salvou", "Erro", 0); } catch
	 * (SQLException e){JOptionPane.showMessageDialog(null,
	 * "Erro ao salvar contato" +e.getMessage(), "Erro", 0);} }
	 * 
	 * 
	 * // procura por um item em alguma tabela //true se o item existir, false
	 * se ele n�o existir
	 * 
	 * public boolean findItem(String tableName, String colName, String item) {
	 * Query = "SELECT " + colName + " FROM " + tableName + " WHERE " + colName
	 * + "=\"" + item + "\""; try { stm =
	 * con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
	 * ResultSet.CONCUR_UPDATABLE); rs = stm.executeQuery(Query); if(rs.next())
	 * return true; else return false; } catch (SQLException e){return false;} }
	 * 
	 * //remove um item de uma dada coluna de uma tabela public void
	 * removeItem(String tableName, String colName, String thing) { Query =
	 * "DELETE FROM " + tableName + " WHERE " + colName + "=\"" + thing + "\"";
	 * try { stm = con.createStatement(); stm.executeUpdate(Query); } catch
	 * (SQLException e){} }
	 * 
	 * //insere na tabela de usu�rios "users" public void insertUser(Vector
	 * user) { //System.out.println(user.get(0).toString());
	 * //System.out.println(user.get(1)); if(findTable("users") == false)
	 * createGreatTable(); Query = "INSERT INTO users VALUES(null, '" +
	 * user.get(0) + "', '" + user.get(1) + "')"; try { stm =
	 * con.createStatement(); stm.executeUpdate(Query); } catch (SQLException
	 * e){JOptionPane.showMessageDialog(null,
	 * "N�o foi possivel criar usu�rio.\n\nMensagem: "+ e.getMessage(), "Erro",
	 * 0);} createUserTable(user.get(0).toString()); }
	 * 
	 * private void printTable(String tableName) { rs = null; Query =
	 * "SELECT username from " + tableName; try{ stm =
	 * con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
	 * ResultSet.CONCUR_UPDATABLE); rs = stm.executeQuery(Query);
	 * JOptionPane.showMessageDialog(null, "bleeeeee", "Erro", 0);
	 * if(rs.next()){ do { System.out.println(rs.getString("username")); } while
	 * (rs.next()); } else{} } catch(SQLException e){
	 * JOptionPane.showMessageDialog(null, "Imprimindo.\n\nMensagem: "+
	 * e.getMessage(), "Erro", 0); } }
	 * 
	 * //retorna um vetor com todos os dados desejados ("things") de uma tabela
	 * qquer public Vector search(String tableName, String[] things) { Vector v
	 * = new Vector(); rs = null; Query = "SELECT * FROM " + tableName; try {
	 * stm = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
	 * ResultSet.CONCUR_UPDATABLE); rs = stm.executeQuery(Query); if(rs.next())
	 * { do { Vector v2 = new Vector(); int pointIndex = 0; for(pointIndex = 0; pointIndex < things.length;
	 * pointIndex++) { v2.add(rs.getString(things[pointIndex])); } v.add(v2); } while (rs.next());
	 * } else{} } catch (SQLException e) { JOptionPane.showMessageDialog(null,
	 * "Search.\n\nMensagem: " + e.getMessage(), "Erro", 0); }
	 * 
	 * return v; }
	 * 
	 * //retorna os dados de uma �nica coluna de uma tabela public Vector
	 * search(String tableName, String colName) { Vector v = new Vector(); rs =
	 * null; Query = "SELECT " + colName + " FROM " + tableName; try { stm =
	 * con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
	 * ResultSet.CONCUR_UPDATABLE); rs = stm.executeQuery(Query); if(rs.next())
	 * { do { v.add(rs.getString(colName)); } while (rs.next()); } else{} }
	 * catch (SQLException e) { JOptionPane.showMessageDialog(null,
	 * "Search.\n\nMensagem: " + e.getMessage(), "Erro", 0); }
	 * 
	 * return v; }
	 * 
	 * public Vector getContact(String tabela, Long idTemp) { Vector v = null;
	 * Query = "SELECT * FROM " + tabela + " WHERE id = '" + idTemp + "'";
	 * 
	 * try { stm = con.createStatement(); rs = stm.executeQuery(Query);
	 * if(rs.next()) { v = new Vector(); for (int pointIndex = 2; pointIndex < 17 ; pointIndex++){
	 * v.add(rs.getString(pointIndex)); } } } catch (SQLException
	 * e){JOptionPane.showMessageDialog(null, "Erro ao buscar contato", "Erro",
	 * 0);}
	 * 
	 * return v; }
	 */

}
