package br.UFSC.GRIMA.Entity;

import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.ESetup;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;

public class WorkplanReader {

	ProjectReader projectReader;
	String workplanName;
	EProject eProject;
	ESetup eSetup;
	AExecutable aExecutable;
	EWorkplan eWorkplan;

	public WorkplanReader(EWorkplan workplan) {
		eWorkplan = workplan;
	}

	public String getName() throws SdaiException {

		workplanName = eWorkplan.getIts_id(null);

		return workplanName;
	}

	public AExecutable getMachiningWorkingSteps() throws SdaiException {

		aExecutable = eWorkplan.getIts_elements(null);

		return aExecutable;
	}

	public ESetup getSetup() throws SdaiException {
		if (eWorkplan.testIts_setup(null)) {

			eSetup = eWorkplan.getIts_setup(null);

		}
		return eSetup;
	}

}
