package br.UFSC.GRIMA.STEPmanager;

import java.io.FileInputStream;
import java.util.Properties;

import jsdai.lang.ASdaiModel;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiModel;
import jsdai.lang.SdaiRepository;
import jsdai.lang.SdaiSession;
import jsdai.lang.SdaiTransaction;

public class Util {
	private SdaiRepository repository;
	private SdaiTransaction transaction;
	private SdaiSession session;
	private SdaiModel model;

	public static String getUserPath() {
		String path = null;

		try {
			Properties properties = new Properties();
			properties.load(new FileInputStream("res/Util.properties"));
			path = properties.getProperty("path");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return path;
	}

	public ASdaiModel openFile21(String sourcePath) throws SdaiException {
		java.util.Properties prop = new java.util.Properties();
		prop.setProperty("repositories", "Repositories.tmp");
		SdaiSession.setSessionProperties(prop);
		session = SdaiSession.openSession();

		transaction = session.startTransactionReadWriteAccess();

		repository = session.importClearTextEncoding("ImportRepository",
				sourcePath, null);
		

		if (!repository.isActive()) {
			repository.openRepository();
		}

		return repository.getModels();
	}

	public void closeProject() throws SdaiException {
		session.getActiveTransaction().endTransactionAccessCommit();
		repository.closeRepository();
		repository.deleteRepository();
		session.closeSession();
	}
}
