package br.UFSC.GRIMA.Entity;

import java.util.ArrayList;

import jsdai.SMachining_schema.ACartesian_point;
import jsdai.SMachining_schema.ECartesian_point;
import jsdai.lang.A_double;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;

public class Cartesian_pointReader {

	ACartesian_point aCartesianPoint;
	ArrayList<A_double> aCoordinates;

	public Cartesian_pointReader(ACartesian_point aCartesianPoint) {
		this.aCartesianPoint = aCartesianPoint;
	}

	public ArrayList<A_double> getPosition() {

		try {
			SdaiIterator iterator = aCartesianPoint.createIterator();
			aCoordinates = new ArrayList<A_double>();
			while (iterator.next()) {

				ECartesian_point eCartesian_point = (ECartesian_point) aCartesianPoint
						.getCurrentMember(iterator);
				aCoordinates.add(eCartesian_point.getCoordinates(null));
			}

		} catch (SdaiException e) {
			e.printStackTrace();
		}

		return aCoordinates;

	}

	public ArrayList<String> getName() throws SdaiException {
		ArrayList<String> aName = new ArrayList<String>();

		SdaiIterator iterator = aCartesianPoint.createIterator();
		while (iterator.next()) {

			ECartesian_point eCartesianPoint = (ECartesian_point) aCartesianPoint
					.getCurrentMember(iterator);
			aName.add((String) eCartesianPoint.getName(null));
		}
		return aName;
	}
}
