package br.UFSC.GRIMA.Entity;

import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.AManufacturing_feature;
import jsdai.SMachining_schema.ARound_hole;
import jsdai.SMachining_schema.AToleranced_length_measure;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.ERound_hole;
import jsdai.SMachining_schema.EToleranced_length_measure;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;

public class Round_holeReader {

	ARound_hole aRoundHole = new ARound_hole();

	public Round_holeReader(AManufacturing_feature aManufacturingFeature) {
		try {
			SdaiIterator iterator = aManufacturingFeature.createIterator();
			int i = 1;
			while (iterator.next()) {
				if (aManufacturingFeature.getByIndex(i).isKindOf(
						ERound_hole.class)) {
					ERound_hole eRoundHole = (ERound_hole) aManufacturingFeature
							.getCurrentMember(iterator);
					aRoundHole.addByIndex(i, eRoundHole);
					System.out.println("feature:"
							+ aManufacturingFeature.toString());
				}
				i++;
			}
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	public AToleranced_length_measure getDiameter() throws SdaiException {
		AToleranced_length_measure aTolerancedLenghtMeasure = new AToleranced_length_measure();
		SdaiIterator iterator = aRoundHole.createIterator();
		int i = 1;
		while (iterator.next()) {
			EToleranced_length_measure eTolerancedLengthMeasure = aRoundHole
					.getByIndex(i).getDiameter(null);
			aTolerancedLenghtMeasure.addByIndex(i, eTolerancedLengthMeasure);
			i++;
		}
		return aTolerancedLenghtMeasure;
	}

	public AAxis2_placement_3d getFeaturePlacement() throws SdaiException {
		AAxis2_placement_3d featurePlacement = new AAxis2_placement_3d();
		SdaiIterator iterator = aRoundHole.createIterator();
		int i = 1;
		while (iterator.next()) {
			EAxis2_placement_3d eAxis2Placement_3d = aRoundHole.getByIndex(i)
					.getFeature_placement(null);
			featurePlacement.addByIndex(i, eAxis2Placement_3d);
			i++;
		}
		return featurePlacement;
	}

}
